#TEMPLATE(PRA,'PRA Templates')
#!==========================================================================
#!
#! Pharmaceutical Research Associates Templates
#!--------------------------------------------------------------------------
#! Template Type  Name                Purpose
#! -------------- ------------------- --------------------------------------
#! PROCEDURE      REPLACE             Substring replacement function
#! EXTENSION      DeclareFilePaths    Declare file paths variables
#! PROCEDURE      AssignFilePaths     Assign file paths variables in PathFile
#! PROCEDURE      GetPathFileRecord   Lookup a record from PathFile
#!==========================================================================
#!==========================================================================
#PROCEDURE(REPLACE,'String REPLACE Function')
#!--------------------------------------------------------------------------
#! DESCRIPTION
#! -----------
#! 
#! -------------------------------------------------------------------------
#! MAINTENANCE HISTORY
#! -------------------
#! DATE          BY            ACTION
#! ------------  ------------  ---------------------------------------------
#! 12-SEPT-1995  MOTT          Created Template v1.003
#!--------------------------------------------------------------------------
#PROTOTYPE('(string,string,string,<<long>),string')
%Procedure %ProcedureType(OldSubstring,NewSubstring,ActionString,N)
#DISPLAY('')
#DISPLAY('PRA String REPLACE Function')
#DISPLAY('')
#DISPLAY('SEND PARAMETERS:')
#DISPLAY('OldSubstring = Substring to Replace')
#DISPLAY('NewSubstring = Substring to use as a Replacement')
#DISPLAY('ActionString = String in which Replacement should occur')
#DISPLAY('N = (Optional) Number of times to replace (Default=ALL)')
#DISPLAY('')
#DISPLAY('RETURNS: String with replacements made')
SubstringStart  LONG(0)
StartSearchPos  LONG(0)
LenOldSubstring LONG(0)
LenNewSubstring LONG(0)
LenActionString LONG(0)
LenAdjustment   LONG(0)
ReplacedCount   LONG(0)
  CODE
  ! Replacement Function Code
  SubstringStart = INSTRING(OldSubstring,ActionString,1,1)
  LenOldSubString = LEN(OldSubString)
  IF SubstringStart AND LenOldSubstring
    LenNewSubstring = LEN(NewSubstring)
    LenActionString = LEN(ActionString)
    LenAdjustment = LenNewSubstring - LenOldSubstring
    IF OMITTED(4) THEN CLEAR(N,1) .   
    LOOP
      ActionString = ActionString[1:(SubStringStart-1)] |
                     & NewSubstring |
                     & ActionString[(SubstringStart+LenOldSubstring): |
                                    LenActionString]
      IF ReplacedCount = N THEN BREAK .
      LenActionString += LenAdjustment
      StartSearchPos = SubstringStart + LenNewSubString
      IF LenActionString - StartSearchPos + 1 < LenOldSubstring THEN BREAK .
      SubstringStart = INSTRING(OldSubstring,ActionString,1,StartSearchPos)
      IF NOT SubstringStart THEN BREAK .
    END
  END
  RETURN(ActionString)
#!=========================================================================
#EXTENSION(DeclareFilePaths,'Declare File Paths'),MULTI,APPLICATION
#!--------------------------------------------------------------------------
#! DESCRIPTION
#! -----------
#!
#! -------------------------------------------------------------------------
#! MAINTENANCE HISTORY
#! -------------------
#! DATE          BY            ACTION
#! ------------  ------------  ---------------------------------------------
#! 12-SEPT-1995  MOTT          Created Template v1.003
#!--------------------------------------------------------------------------
#BOXED('DECLARE FILE PATHS')
 #BOXED('')
  #DISPLAY('A global path variable is declared for each file')
  #DISPLAY('specified in the "File List" (button below) using')
  #DISPLAY('the specified declaration attribute.  This template')
  #DISPLAY('may be used multiple times in an application where')
  #DISPLAY('file path variables require different attributes.')
  #DISPLAY('Path variable names come directly from the')
  #DISPLAY('"File Name" specified in the dictionary for the file.')
 #ENDBOXED
 #PROMPT('Files:',FROM(%File,(NOT INLIST(%File,%DeclaredPaths)),%File)),%DeclaredPaths,REQ,MULTI('File List')
 #VALIDATE((ITEMS(%DeclaredPaths)),'At least one File required!')
 #ENABLE(ITEMS(%DeclaredPaths))
  #PROMPT('Declaration Attributes:',@s40),%FilePathAttrib
 #ENDENABLE
#ENDBOXED
#AT(%BeforeFileDeclarations)
!Start Declarations Generated for File Setup
  #FOR(%File)
   #IF(INLIST(%File,%DeclaredPaths))
%FileName              STRING(80)%FilePathAttrib
   #ENDIF
  #ENDFOR
!End Declarations Generated for File Setup
#ENDAT
#AT(%DLLExportList),WHERE(%ProgramExtension='DLL')
  #FOR(%File)
   #IF(INLIST(%File,%DeclaredPaths))
    #IF(NOT INSTRING('EXTERNAL',UPPER(%FilePathAttrib),1,1))
     #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $%FileName   @%ExpLineNumber
    #ENDIF
   #ENDIF
  #ENDFOR
#ENDAT
#!=========================================================================
#PROCEDURE(AssignFilePaths,'Assign File Paths')
#!--------------------------------------------------------------------------
#! DESCRIPTION
#! -----------
#!
#! -------------------------------------------------------------------------
#! MAINTENANCE HISTORY
#! -------------------
#! DATE          BY            ACTION
#! ------------  ------------  ---------------------------------------------
#! 12-SEPT-1995  MOTT          Created Template v1.003
#!--------------------------------------------------------------------------
#PROTOTYPE('(),long')
#BOXED('Assign File Paths Function')
 #DISPLAY('PARAMETERS: None (Files="OtherFiles" are setup)')
 #DISPLAY('RETURNS:       TRUE, if error free setup. ')
 #DISPLAY('  1. Closes specified files.')
 #DISPLAY('  2. Reads PathFile entries for specified files.')
 #DISPLAY('  3. Assigns path variables based on Pathfile entries.')
 #BUTTON(' Path Assignment Options'),AT(100)
  #PROMPT('1. Set Drive =',@s30),%SetDrive
   #ENABLE(%SetDrive),CLEAR
    #PROMPT('Override Drive Entry',CHECK),%OverrideDrive
   #ENDENABLE
   #PROMPT('2. Replace "[Client]" =',@s30),%ReplaceClient
   #PROMPT('3. Replace "[Study]" =',@s30),%ReplaceStudy
   #PROMPT('4. Replace "[Stamp]" =',@s30),%ReplaceStamp
   #PROMPT('5. Replace this =',@s30),%ReplaceWildOld
   #ENABLE(%ReplaceWildOld),CLEAR
    #PROMPT('       ...with this =',@s30),%ReplaceWildNew
   #ENDENABLE
   #PROMPT('6. Drive-to-Path Delimiter =',@s30),%DrivePathDel,DEFAULT(''':\''')
   #PROMPT('7. Path-to-File Delimiter =',@s30),%PathFileDel,DEFAULT('''\''')
 #ENDBUTTON
 #BOXED('Setup Error Control')
  #PROMPT('Stop on first Error',CHECK),%StopSetup,AT(20)
 #ENDBOXED
 #BOXED('PathFile Options')
  #PROMPT('OPEN PathFile',CHECK),%OpenPathFile,AT(20)
  #ENABLE(%OpenPathFile),CLEAR
   #PROMPT('Reset PathFile Path=',@s80),%SetPathFile
  #ENDENABLE
 #ENDBOXED
#ENDBOXED
%Procedure %ProcedureType
SetupSuccess  LONG(1)
FileVar       &File
FileUsedVar   &LONG
FilePathVar   &STRING
FileName      STRING(80)
FilePathName  STRING(80)
  CODE
!Start File Setups
 #IF(%OpenPathFile)
  #IF(%SetPathFile)
   #FIX(%File,'PathFile')
   #IF(%File)
  IF PathFile::Used and (%FileName <> %SetPathFile)
    IF MESSAGE('Attempt to reset path on open file: PathFile', |
                'ERROR: FILE WILL BE CLOSED AND RESET!') .
    CLOSE(PathFile)     !Closed for safety, since path is being reset next.
    SetupSuccess = 0
    PathFile::Used = 0
    %FileName = %SetPathFile
  ELSIF PathFile::Used and (%FileName = %SetPathFile)
    !File is open and set already so do nothing
  ELSE
    CLOSE(PathFile)     !Closed for safety, since path is being reset next.
    PathFile::Used = 0
    %FileName = %SetPathFile
  END
   #ELSE
    #ERROR('SETUP ERROR:"PathFile" not found in Dictionary.')
   #ENDIF
  #ENDIF
  IF PathFile::Used = 0
    CheckOpen(PathFile,1)
  END
  PathFile::Used += 1
 #ENDIF
 #FOR(%File)
  #IF(INLIST(%File,%OtherFiles) AND (%File <> 'PathFile'))
!--------------------------------------------------------------------------
   #IF(%StopSetup)
  IF SetupSuccess
   #ENDIF
    FileVar      &= %File
    FileUsedVar  &= %File::Used
    FilePathVar  &= %FileName
    FileName     = '%File'
    FilePathName = '%FileName'
    DO SetupTheFile
   #IF(%StopSetup)
  END  ! (IF SetupSuccess)
   #ENDIF
  #ENDIF
 #ENDFOR
!--------------------------------------------------------------------------
!End File Setups
 #IF(%OpenPathFile)
  PathFile::Used -= 1
  IF PathFile::Used = 0 THEN CLOSE(PathFile). !Close PathFile when Done.
 #ENDIF
  RETURN(SetupSuccess)
SetupTheFile            ROUTINE
  IF FileUsedVar
    IF MESSAGE('Attempt to reset path on open file: '& CLIP(FileName), |
                        'ERROR: FILE WILL BE CLOSED AND RESET!') .
    SetupSuccess = 0
  END
  CLOSE(FileVar)     !Closed for safety, since path is being reset next.
  FileUsedVar = 0
  !Get Requested File Path from Path File
  CLEAR(Pth:RECORD)
  Pth:FileNameVariable = FilePathName
  GET(PathFile,Pth:FileNameKey)
  IF ERRORCODE() OR NOT Pth:FileName
    IF MESSAGE('ERROR:'&ERRORCODE()&'-Invalid "'&CLIP(FilePathName)&'" Record!', |
               'PATH FILE SETUP ERROR!') .
    SetupSuccess = 0
    FilePathVar = ''
  ELSE
 #IF(%OverrideDrive)
    Pth:FileDrive = %SetDrive
 #ELSIF(%SetDrive)
    IF NOT Pth:FileDrive THEN Pth:FileDrive = %SetDrive.
 #ENDIF
    FilePathVar = LEFT(CLIP(Pth:FileName))
    IF Pth:FilePath THEN FilePathVar=LEFT(CLIP(Pth:FilePath)&%PathFileDel&FilePathVar).
    IF Pth:FileDrive THEN FilePathVar=LEFT(CLIP(Pth:FileDrive)&%DrivePathDel&FilePathVar).
 #IF(%ReplaceClient)
    FilePathVar=REPLACE('[CLIENT]',%ReplaceClient,UPPER(FilePathVar))
 #ENDIF
 #IF(%ReplaceStudy)
    FilePathVar = REPLACE('[STUDY]',%ReplaceStudy,UPPER(FilePathVar))
 #ENDIF
 #IF(%ReplaceStamp)
    FilePathVar = REPLACE('[STAMP]',%ReplaceStamp,UPPER(FilePathVar))
 #ENDIF
 #IF(%ReplaceWildOld)
    FilePathVar = REPLACE(UPPER(%ReplaceWildOld),%ReplaceWildNew,UPPER(FilePathVar))
 #ENDIF
  END
  EXIT
#!=========================================================================
#PROCEDURE(GetPathFileRecord,'Get a PathFile Record')
#!--------------------------------------------------------------------------
#! DESCRIPTION
#! -----------
#!
#! -------------------------------------------------------------------------
#! MAINTENANCE HISTORY
#! -------------------
#! DATE          BY            ACTION
#! ------------  ------------  ---------------------------------------------
#! 12-SEPT-1995  MOTT          Created Template v1.003
#!--------------------------------------------------------------------------
#PROTOTYPE('(string),string')
#BOXED('Get PathFile Record Function')
 #DISPLAY('PARAMETERS: Path File Record ID')
 #DISPLAY('RETURNS:       Path File Entry, if error free setup. ')
 #DISPLAY('')
 #DISPLAY('REMEMBER: CLOSE FILE BEFORE CHANGING PATH!')
 #DISPLAY('')
 #BUTTON(' Path Assignment Options'),AT(100)
  #PROMPT('1. Set Drive =',@s30),%SetDrive
   #ENABLE(%SetDrive),CLEAR
    #PROMPT('Override Drive Entry',CHECK),%OverrideDrive
   #ENDENABLE
   #PROMPT('2. Replace "[Client]" =',@s30),%ReplaceClient
   #PROMPT('3. Replace "[Study]" =',@s30),%ReplaceStudy
   #PROMPT('4. Replace "[Stamp]" =',@s30),%ReplaceStamp
   #PROMPT('5. Replace this =',@s30),%ReplaceWildOld
   #ENABLE(%ReplaceWildOld),CLEAR
    #PROMPT('       ...with this =',@s30),%ReplaceWildNew
   #ENDENABLE
   #PROMPT('6. Drive-to-Path Delimiter =',@s30),%DrivePathDel,DEFAULT(''':\''')
   #PROMPT('7. Path-to-File Delimiter =',@s30),%PathFileDel,DEFAULT('''\''')
 #ENDBUTTON
 #BOXED('PathFile Options')
  #PROMPT('OPEN PathFile',CHECK),%OpenPathFile,AT(20)
  #ENABLE(%OpenPathFile),CLEAR
   #PROMPT('Reset PathFile Path=',@s80),%SetPathFile
  #ENDENABLE
 #ENDBOXED
#ENDBOXED
%Procedure %ProcedureType(FileSpecVar)
SetupSuccess  LONG(1)
ReturnName  STRING(255)
  CODE
  ReturnName = ''
 #IF(%OpenPathFile)
  #IF(%SetPathFile)
   #FIX(%File,'PathFile')
   #IF(%File)
  IF PathFile::Used and (%FileName <> %SetPathFile)
    IF MESSAGE('Attempt to reset path on open file: PathFile', |
                'ERROR: FILE WILL BE CLOSED AND RESET!') .
    CLOSE(PathFile)     !Closed for safety, since path is being reset next.
    SetupSuccess = 0
    PathFile::Used = 0
    %FileName = %SetPathFile
  ELSIF PathFile::Used and (%FileName = %SetPathFile)
    !File is open and set already so do nothing
  ELSE
    CLOSE(PathFile)     !Closed for safety, since path is being reset next.
    PathFile::Used = 0
    %FileName = %SetPathFile
  END
   #ELSE
    #ERROR('SETUP ERROR:"PathFile" not found in Dictionary.')
   #ENDIF
  #ENDIF
  IF PathFile::Used = 0
    CheckOpen(PathFile,1)
  END
  PathFile::Used += 1
 #ENDIF
  IF SetupSuccess
    !Get Requested File Path from Path File
    CLEAR(Pth:RECORD)
    Pth:FileNameVariable = FileSpecVar
    GET(PathFile,Pth:FileNameKey)
    IF ERRORCODE() OR NOT Pth:FileName
      IF MESSAGE('ERROR:'&ERRORCODE()&'-Invalid "'&CLIP(FileSpecVar)&'" Record!', |
                 'PATH FILE SETUP ERROR!') .
      SetupSuccess = 0
    ELSE
   #IF(%OverrideDrive)
      Pth:FileDrive = %SetDrive
   #ELSIF(%SetDrive)
      IF NOT Pth:FileDrive THEN Pth:FileDrive = %SetDrive.
   #ENDIF
      ReturnName = LEFT(CLIP(Pth:FileName))
      IF Pth:FilePath THEN ReturnName=LEFT(CLIP(Pth:FilePath)&%PathFileDel&ReturnName).
      IF Pth:FileDrive THEN ReturnName=LEFT(CLIP(Pth:FileDrive)&%DrivePathDel&ReturnName).
   #IF(%ReplaceClient)
      ReturnName=REPLACE('[CLIENT]',%ReplaceClient,UPPER(ReturnName))
   #ENDIF
   #IF(%ReplaceStudy)
      ReturnName = REPLACE('[STUDY]',%ReplaceStudy,UPPER(ReturnName))
   #ENDIF
   #IF(%ReplaceStamp)
      ReturnName = REPLACE('[STAMP]',%ReplaceStamp,UPPER(ReturnName))
   #ENDIF
   #IF(%ReplaceWildOld)
      ReturnName = REPLACE(UPPER(%ReplaceWildOld),%ReplaceWildNew,UPPER(ReturnName))
   #ENDIF
    END
  END  ! (IF SetupSuccess)
 #IF(%OpenPathFile)
  PathFile::Used -= 1
  IF PathFile::Used = 0 THEN CLOSE(PathFile). !Close PathFile when Done.
 #ENDIF
  RETURN(ReturnName)
#!=========================================================================
